function m_genBaoIntilleAccArffData()
% Generate Arff files for Bao-Intille acceleration data for activity recognition
% This is not part of SegSVM code, its main purpose is to generate Weka-competible 
% data to test if the function m_cmpBaoIntilleFeats does what is supposed to do.
% By Minh Hoai Nguyen (minhhoai@gmail.com)
% Date 20 Apr 2011

dataDir = '/Users/hoai/DataSets/LingAcceleration/dataset/activity';
outDir = '/Users/hoai/DataSets_proc/LingAcceleration/activity/';
winSz = 512;

files = ml_getFilesInDir(dataDir, 'mat');
nPeople = length(files);
nAction = 21;
nSensor = 5;
Feats= cell(nPeople, nAction);
lbs = cell(nPeople, nAction);

for i=1:nPeople
    load(files{i}, 'actdata');
    
    for actId=1:nAction
        fprintf('processing file %d/%d, action %d/%d\n', i, nPeople, actId, nAction);
        minNoFrm = inf;
        for sensorId=1:nSensor
            minNoFrm = min(minNoFrm, size(actdata{actId, sensorId},2));
        end;
        D = cell(1, nSensor);
        for sensorId=1:nSensor
            D{sensorId} = actdata{actId,sensorId}(:, 1:minNoFrm);
        end;
        D = cat(1, D{:});
        Feats{i, actId} = m_cmpBaoIntilleFeats(D, winSz);
        lbs{i, actId} = actId*ones(size(Feats{i, actId},2), 1);
    end;
end;

for i=1:nPeople
    trainFile = [outDir, sprintf('train_%02d.arff', i)];
    testFile = [outDir, sprintf('test_%02d.arff', i)];
    Feat = cat(2, Feats{[1:i-1, i+1:nPeople],:});
    lb = cat(1, lbs{[1:i-1, i+1:nPeople],:}); 
    ml_data2arff(Feat, lb, [], trainFile);
    Feat = cat(2, Feats{i,:});
    lb = cat(1, lbs{i,:});
    ml_data2arff(Feat, lb, [], testFile);
end;
