/*
 * m_utils.h
 *
 * Created on: Jul 29, 2009
 * Author: Minh Hoai Nguyen, Carnegie Mellon University
 * Email:  minhhoai@cmu.edu, minhhoai@gmail.com
 */

#ifndef M_UTILS_H_
#define M_UTILS_H_

#include <ctime>
#include <ilcplex/ilocplex.h>

/* Compute the time difference in seconds between two time stamps */
double diffclock(clock_t clock1,clock_t clock2);

/* Test if newVec deviates substantially from oldVec */
bool isDeviateEnough(IloNumArray newVec, double *oldVec, double *deviation);

/* calculate svmVals= Feats'*w + b;
 * Feat is a nBin*n matrix
 * w is nBin*1 vector
 */
double *cmpSVMVals(double *Feat, int n, int nBin,  double *w, IloNum b);

void cmpMCSVMVals(double const *Feat, int const *classIdxs, double const *w,
      int n, int nBin, double *svmVals);

template<typename Type>
Type** buildMatrix(int mRows, int nCols){
   Type **imPr = new Type* [mRows];
   for (int i=0; i<mRows; i++){
      imPr[i] = new Type[nCols];
   }
   return imPr;
}

template<typename Type>
void destroyMatrix(Type **imPr, int mRows, int nCols){
   for (int i=0; i<mRows; i++){
      delete [] imPr[i];
   }
   delete [] imPr;
}


#endif /* M_UTILS_H_ */
