function files = ml_getFilesInDir(dirPath, ext)   
% files = ml_getFilesInDir(dirPath, ext)   
% Get all files in a directory with extension ext
% Minh Hoai Nguyen (minhhoai@cmu.edu)
% Date: 20 July 09

if exist('ext', 'var') && ~isempty(ext)
    fls = dir([dirPath, '/*.', ext]);
    files = cell(1, length(fls));
    for i=1:length(files)
        files{i} = [dirPath, '/', fls(i).name];
    end;
else
    fls = dir(dirPath);
    files = cell(1, length(fls) - 2);
    for i=1:length(files)
        files{i} = [dirPath, '/', fls(i+2).name];
    end;
end;